
player = {
     width = 40,
     height = 40,
     x = 170,
     y = 120,
     xvel = 0,
     yvel = 0,
     friction = 7,
     speed = 1200,
     gravity = 900,
     jumping = false,
     jump = 400,
     face = 'right',
     health = 3
     }
playerR = {}
playerL = {}
player.animtimer = 0

player.pnum = 1

function player.load()
     playerR= {gr.newImage('art/playerR1.png'),gr.newImage('art/playerR2.png'),gr.newImage('art/playerR3.png'),
gr.newImage('art/playerR4.png'),gr.newImage('art/playerR5.png')}

playerL= {gr.newImage('art/playerL1.png'),gr.newImage('art/playerL2.png'),gr.newImage('art/playerL3.png'),
gr.newImage('art/playerL4.png'),gr.newImage('art/playerL5.png')}
player.pic = playerR[1]

end

function player.draw()
    gr.setColor(255,255,255,255)
    draw(player.pic,player.x,player.y,0,2,2)
end

function player.physics(dt)
    player.x = player.x + player.xvel * dt
    player.y = player.y + player.yvel * dt
    player.yvel = player.yvel + player.gravity * dt
    player.xvel = player.xvel * (1 - math.min(dt * player.friction, 1))
end

function player.move(dt)
    if love.keyboard.isDown('d') and player.xvel < player.speed then
        player.xvel = player.xvel + player.speed * dt
        player.face ='right'
        player.pic = playerR[player.pnum]
        player.animtimer = player.animtimer + dt
        if player.animtimer > 0.1 then
            player.pnum = player.pnum + 1
            player.animtimer = 0
        end
        if player.pnum >= #playerR then
            player.pnum = 1
        end
    end
    if love.keyboard.isDown('a') and player.xvel > -player.speed then
        player.xvel = player.xvel - player.speed * dt
        player.face ='left'
        player.pic = playerL[player.pnum]
        player.animtimer = player.animtimer + dt
        if player.animtimer > 0.1 then
            player.pnum = player.pnum + 1
            player.animtimer = 0
        end
        if player.pnum >= #playerL then
            player.pnum = 1
        end
    end
    if love.keyboard.isDown('w') then
        if (player.jumping == false) then
            player.yvel = player.jump - player.gravity
            player.jumping = true
        end
    end
end

function player.animreset(key)
    if key == 'd' then
        player.animtimer = 0
        player.pnum=1
        player.pic = playerR[1]
    end
    if key == 'a' then
        player.animtimer = 0
        player.pnum=1
        player.pic = playerL[1]
    end
end

function UPDATE_PLAYER(dt)
    player.physics(dt)
    player.move(dt)
end

